=== modified file 'client/drizzledump.cc'
--- client/drizzledump.cc	2008-09-08 05:34:16 +0000
+++ client/drizzledump.cc	2008-09-14 00:14:42 +0000
@@ -1112,7 +1112,7 @@
   if (!(tmp=(char*) my_malloc(length*2+1, MYF(MY_WME))))
     die(EX_DRIZZLEERR, "Couldn't allocate memory");
 
-  drizzle_real_escape_string(&drizzle_connection, tmp, pos, length);
+  drizzle_escape_string(tmp, pos, length);
   fputc('\'', file);
   fputs(tmp, file);
   fputc('\'', file);
@@ -2278,9 +2278,8 @@
                 else
                 {
                   extended_row.append("'");
-                  drizzle_real_escape_string(&drizzle_connection,
-                                             tmp_str,
-                                             row[i],length);
+                  drizzle_escape_string(tmp_str,
+                                        row[i],length);
                   extended_row.append(tmp_str);
                   extended_row.append("'");
                 }

=== modified file 'client/drizzleimport.cc'
--- client/drizzleimport.cc	2008-09-08 05:34:16 +0000
+++ client/drizzleimport.cc	2008-09-14 00:14:42 +0000
@@ -482,9 +482,6 @@
   char *raw_table_name= (char *)arg;
   DRIZZLE *drizzle= 0;
 
-  if (drizzle_thread_init())
-    goto error;
- 
   if (!(drizzle= db_connect(current_host,current_db,current_user,opt_password)))
   {
     goto error;

=== modified file 'client/drizzleslap.cc'
--- client/drizzleslap.cc	2008-09-06 00:05:54 +0000
+++ client/drizzleslap.cc	2008-09-14 00:14:42 +0000
@@ -319,9 +319,6 @@
 
   MY_INIT(argv[0]);
 
-  if (!(drizzle_thread_safe()))
-    fprintf(stderr, "This application was compiled incorrectly. Please recompile with thread support.\n");
-
   load_defaults("my",load_default_groups,&argc,&argv);
   defaults_argv=argv;
   if (get_options(&argc,&argv))
@@ -1963,14 +1960,6 @@
   struct timespec abstime;
 
 
-
-  if (drizzle_thread_init())
-  {
-    fprintf(stderr,"%s: drizzle_thread_init() failed.\n",
-            my_progname);
-    exit(1);
-  }
-
   /*
     We lock around the initial call in case were we in a loop. This
     also keeps the value properly syncronized across call threads.
@@ -1992,7 +1981,6 @@
   timer_alarm= false;
   pthread_mutex_unlock(&timer_alarm_mutex);
 
-  drizzle_thread_end();
   return(0);
 }
 
@@ -2007,13 +1995,6 @@
   statement *ptr;
   thread_context *con= (thread_context *)p;
 
-  if (drizzle_thread_init())
-  {
-    fprintf(stderr,"%s: drizzle_thread_init() failed.\n",
-            my_progname);
-    exit(1);
-  }
-
   pthread_mutex_lock(&sleeper_mutex);
   while (master_wakeup)
   {
@@ -2139,7 +2120,6 @@
 
   my_free(con, MYF(0));
 
-  drizzle_thread_end();
   return(0);
 }
 

=== modified file 'drizzled/log_event.cc'
--- drizzled/log_event.cc	2008-09-08 05:34:16 +0000
+++ drizzled/log_event.cc	2008-09-14 00:14:42 +0000
@@ -31,6 +31,7 @@
 #include <mysys/my_bitmap.h>
 
 #include <libdrizzle/gettext.h>
+#include <libdrizzle/drizzle.h>
 
 #define log_cs	&my_charset_utf8_general_ci
 
@@ -459,8 +460,7 @@
   else
   {
     *ptr++= '\'';
-    ptr+= escape_string_for_drizzle(csinfo, ptr, 0,
-                                    from->ptr(), from->length());
+    ptr+= drizzle_escape_string(ptr, from->ptr(), from->length());
     *ptr++='\'';
   }
   to->length(orig_len + ptr - beg);

=== modified file 'libdrizzle/client.c'
--- libdrizzle/client.c	2008-09-08 05:34:16 +0000
+++ libdrizzle/client.c	2008-09-14 00:14:42 +0000
@@ -1,7 +1,7 @@
 /* - mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
  *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
  *
- *  Copyright (C) 2008 MySQL
+ *  Copyright (C) 2008 Sun Microsystems
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -1077,17 +1077,9 @@
   else
   {
     free_charsets();
-    drizzle_thread_end();
   }
 
   drizzle_client_init= org_my_init_done= 0;
-#ifdef EMBEDDED_SERVER
-  if (stderror_file)
-  {
-    fclose(stderror_file);
-    stderror_file= 0;
-  }
-#endif
 }
 
 

=== modified file 'libdrizzle/drizzle.h'
--- libdrizzle/drizzle.h	2008-09-10 04:46:12 +0000
+++ libdrizzle/drizzle.h	2008-09-14 00:14:42 +0000
@@ -286,14 +286,6 @@
 
 const DRIZZLE_PARAMETERS * drizzle_get_parameters(void);
 
-/*
-  Set up and bring down a thread; these function should be called
-  for each thread in an application which opens at least one MySQL
-  connection.  All uses of the connection(s) should be between these
-  function calls.
-*/
-bool drizzle_thread_init(void);
-void drizzle_thread_end(void);
 
 /*
   Functions to get information from the DRIZZLE and DRIZZLE_RES structures
@@ -381,10 +373,7 @@
 DRIZZLE_RES *     drizzle_list_fields(DRIZZLE *drizzle, const char *table, const char *wild);
 uint32_t  drizzle_escape_string(char *to,const char *from, uint32_t from_length);
 uint32_t  drizzle_hex_string(char *to,const char *from, uint32_t from_length);
-uint32_t        drizzle_real_escape_string(DRIZZLE *drizzle, char *to, const char *from, uint32_t length);
 void    myodbc_remove_escape(const DRIZZLE *drizzle, char *name);
-uint32_t  drizzle_thread_safe(void);
-bool    drizzle_embedded(void);
 bool         drizzle_read_query_result(DRIZZLE *drizzle);
 
 

=== modified file 'libdrizzle/libdrizzle.c'
--- libdrizzle/libdrizzle.c	2008-09-10 00:06:50 +0000
+++ libdrizzle/libdrizzle.c	2008-09-14 00:14:42 +0000
@@ -18,7 +18,6 @@
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
 
 #include <drizzled/global.h>
-#include <mysys/my_sys.h>
 #include "drizzle.h"
 #include "errmsg.h"
 #include <sys/stat.h>
@@ -53,6 +52,21 @@
 #include "client_settings.h"
 #include <drizzled/version.h>
 
+/* Borrowed from libicu header */
+
+#define U8_IS_SINGLE(c) (((c)&0x80)==0)
+#define U8_LENGTH(c) \
+    ((uint32_t)(c)<=0x7f ? 1 : \
+        ((uint32_t)(c)<=0x7ff ? 2 : \
+            ((uint32_t)(c)<=0xd7ff ? 3 : \
+                ((uint32_t)(c)<=0xdfff || (uint32_t)(c)>0x10ffff ? 0 : \
+                    ((uint32_t)(c)<=0xffff ? 3 : 4)\
+                ) \
+            ) \
+        ) \
+    )
+
+
 #undef net_buffer_length
 #undef max_allowed_packet
 
@@ -78,17 +92,6 @@
   return &drizzle_internal_parameters;
 }
 
-bool drizzle_thread_init()
-{
-  return my_thread_init();
-}
-
-void drizzle_thread_end()
-{
-  my_thread_end();
-}
-
-
 /*
   Expand wildcard to a sql string
 */
@@ -538,33 +541,6 @@
   return drizzle->charset->csname;
 }
 
-void drizzle_get_character_set_info(const DRIZZLE *drizzle, MY_CHARSET_INFO *csinfo)
-{
-  csinfo->number   = drizzle->charset->number;
-  csinfo->state    = drizzle->charset->state;
-  csinfo->csname   = drizzle->charset->csname;
-  csinfo->name     = drizzle->charset->name;
-  csinfo->comment  = drizzle->charset->comment;
-  csinfo->mbminlen = drizzle->charset->mbminlen;
-  csinfo->mbmaxlen = drizzle->charset->mbmaxlen;
-
-  if (drizzle->options.charset_dir)
-    csinfo->dir = drizzle->options.charset_dir;
-  else
-    csinfo->dir = charsets_dir;
-}
-
-uint drizzle_thread_safe(void)
-{
-  return 1;
-}
-
-
-bool drizzle_embedded(void)
-{
-  return false;
-}
-
 /****************************************************************************
   Some support functions
 ****************************************************************************/
@@ -596,9 +572,7 @@
   Each character needs two bytes, and you need room for the terminating
   null byte. When drizzle_hex_string() returns, the contents of "to" will
   be a null-terminated string. The return value is the length of the
-  encoded string, not including the terminating null character.
-
-  The return value does not contain any leading 0x or a leading X' and
+  encoded string, not including the terminating null character.  The return value does not contain any leading 0x or a leading X' and
   trailing '. The caller must supply whichever of those is desired.
 */
 
@@ -626,17 +600,73 @@
 uint32_t
 drizzle_escape_string(char *to,const char *from, uint32_t length)
 {
-  return escape_string_for_drizzle(default_charset_info, to, 0, from, length);
+  const char *to_start= to;
+  const char *end, *to_end=to_start + 2*length;
+  bool overflow= false;
+  for (end= from + length; from < end; from++)
+  {
+    uint32_t tmp_length;
+    char escape= 0;
+    if (!U8_IS_SINGLE(*from))
+    {
+      tmp_length= U8_LENGTH(*from);
+      if (to + tmp_length > to_end)
+      {
+        overflow= true;
+        break;
+      }
+      while (tmp_length--)
+        *to++= *from++;
+      from--;
+      continue;
+    }
+    switch (*from) {
+    case 0:                             /* Must be escaped for 'mysql' */
+      escape= '0';
+      break;
+    case '\n':                          /* Must be escaped for logs */
+      escape= 'n';
+      break;
+    case '\r':
+      escape= 'r';
+      break;
+    case '\\':
+      escape= '\\';
+      break;
+    case '\'':
+      escape= '\'';
+      break;
+    case '"':                           /* Better safe than sorry */
+      escape= '"';
+      break;
+    case '\032':                        /* This gives problems on Win32 */
+      escape= 'Z';
+      break;
+    }
+    if (escape)
+    {
+      if (to + 2 > to_end)
+      {
+        overflow= true;
+        break;
+      }
+      *to++= '\\';
+      *to++= escape;
+    }
+    else
+    {
+      if (to + 1 > to_end)
+      {
+        overflow= true;
+        break;
+      }
+      *to++= *from;
+    }
+  }
+  *to= 0;
+  return overflow ? (size_t) -1 : (size_t) (to - to_start);
 }
 
-uint32_t
-drizzle_real_escape_string(DRIZZLE *drizzle, char *to,const char *from,
-       uint32_t length)
-{
-  if (drizzle->server_status & SERVER_STATUS_NO_BACKSLASH_ESCAPES)
-    return escape_quotes_for_drizzle(drizzle->charset, to, 0, from, length);
-  return escape_string_for_drizzle(drizzle->charset, to, 0, from, length);
-}
 
 void
 myodbc_remove_escape(const DRIZZLE *drizzle, char *name)

=== modified file 'mysys/charset.c'
--- mysys/charset.c	2008-09-08 05:34:16 +0000
+++ mysys/charset.c	2008-09-14 00:14:42 +0000
@@ -404,121 +404,6 @@
 }
 
 
-/*
-  Escape string with backslashes (\)
-
-  SYNOPSIS
-    escape_string_for_drizzle()
-    charset_info        Charset of the strings
-    to                  Buffer for escaped string
-    to_length           Length of destination buffer, or 0
-    from                The string to escape
-    length              The length of the string to escape
-
-  DESCRIPTION
-    This escapes the contents of a string by adding backslashes before special
-    characters, and turning others into specific escape sequences, such as
-    turning newlines into \n and null bytes into \0.
-
-  NOTE
-    To maintain compatibility with the old C API, to_length may be 0 to mean
-    "big enough"
-
-  RETURN VALUES
-    (size_t) -1 The escaped string did not fit in the to buffer
-    #           The length of the escaped string
-*/
-
-size_t escape_string_for_drizzle(const CHARSET_INFO *charset_info,
-                                 char *to, size_t to_length,
-                                 const char *from, size_t length)
-{
-  const char *to_start= to;
-  const char *end, *to_end=to_start + (to_length ? to_length-1 : 2*length);
-  bool overflow= false;
-#ifdef USE_MB
-  bool use_mb_flag= use_mb(charset_info);
-#endif
-  for (end= from + length; from < end; from++)
-  {
-    char escape= 0;
-#ifdef USE_MB
-    int tmp_length;
-    if (use_mb_flag && (tmp_length= my_ismbchar(charset_info, from, end)))
-    {
-      if (to + tmp_length > to_end)
-      {
-        overflow= true;
-        break;
-      }
-      while (tmp_length--)
-	*to++= *from++;
-      from--;
-      continue;
-    }
-    /*
-     If the next character appears to begin a multi-byte character, we
-     escape that first byte of that apparent multi-byte character. (The
-     character just looks like a multi-byte character -- if it were actually
-     a multi-byte character, it would have been passed through in the test
-     above.)
-
-     Without this check, we can create a problem by converting an invalid
-     multi-byte character into a valid one. For example, 0xbf27 is not
-     a valid GBK character, but 0xbf5c is. (0x27 = ', 0x5c = \)
-    */
-    if (use_mb_flag && (tmp_length= my_mbcharlen(charset_info, *from)) > 1)
-      escape= *from;
-    else
-#endif
-    switch (*from) {
-    case 0:				/* Must be escaped for 'mysql' */
-      escape= '0';
-      break;
-    case '\n':				/* Must be escaped for logs */
-      escape= 'n';
-      break;
-    case '\r':
-      escape= 'r';
-      break;
-    case '\\':
-      escape= '\\';
-      break;
-    case '\'':
-      escape= '\'';
-      break;
-    case '"':				/* Better safe than sorry */
-      escape= '"';
-      break;
-    case '\032':			/* This gives problems on Win32 */
-      escape= 'Z';
-      break;
-    }
-    if (escape)
-    {
-      if (to + 2 > to_end)
-      {
-        overflow= true;
-        break;
-      }
-      *to++= '\\';
-      *to++= escape;
-    }
-    else
-    {
-      if (to + 1 > to_end)
-      {
-        overflow= true;
-        break;
-      }
-      *to++= *from;
-    }
-  }
-  *to= 0;
-  return overflow ? (size_t) -1 : (size_t) (to - to_start);
-}
-
-
 #ifdef BACKSLASH_MBTAIL
 static CHARSET_INFO *fs_cset_cache= NULL;
 

=== modified file 'storage/archive/concurrency_test.c'
--- storage/archive/concurrency_test.c	2008-08-09 06:22:13 +0000
+++ storage/archive/concurrency_test.c	2008-09-14 00:14:42 +0000
@@ -87,9 +87,6 @@
   if (argc > 1)
     exit(1);
 
-  if (!(drizzle_thread_safe()))
-      fprintf(stderr, "This application was compiled incorrectly. Please recompile with thread support.\n");
-
   srandom(time(NULL));
 
   pthread_mutex_init(&counter_mutex, NULL);
@@ -215,13 +212,6 @@
   time_t *timer_length= (time_t *)p;
   struct timespec abstime;
 
-  if (drizzle_thread_init())
-  {
-    fprintf(stderr,"%s: drizzle_thread_init() failed.\n",
-            my_progname);
-    exit(1);
-  }
-
   /* 
     We lock around the initial call in case were we in a loop. This 
     also keeps the value properly syncronized across call threads.
@@ -243,8 +233,6 @@
   timer_alarm= false;
   pthread_mutex_unlock(&timer_alarm_mutex);
 
-  drizzle_thread_end();
-
   return 0;
 }
 
@@ -256,12 +244,6 @@
   int error;
   azio_stream reader_handle;
 
-  if (drizzle_thread_init())
-  {
-    fprintf(stderr,"%s: drizzle_thread_init() failed.\n", my_progname);
-    exit(1);
-  }
-
   if (!(ret= azopen(&reader_handle, TEST_FILENAME, O_RDONLY|O_BINARY,
                     context->use_aio)))
   {
@@ -300,8 +282,6 @@
   pthread_mutex_unlock(&counter_mutex);
   azclose(&reader_handle);
 
-  drizzle_thread_end();
-
   return NULL;
 }
 

